<?php
	class Coupon {
		var $connection;
		var $kartRecordset;
		var $couponTable;
		var $couponPK;
		var $couponPrdFK;
		var $couponDiscount;
		var $couponStartDate;
		var $couponEndDate;
		var $sessionCoupons;
		var $isProcent;
		
		/**
			constructor
		*/
		function Coupon($oldPrice) {
			$this->oldPrice = $oldPrice;
			$this->kartObject = krt_getKartRecordsetNoMove();
		}

		/**
			set The Conection Object
			@params
				$connection - ADODB Connection reference
			@return
			none
		*/
		function setConnection(&$conn) {
			$this->connection = &$conn;
		}
		
		/**
			set the coupon table
		*/
		function setCouponTable($couponTable,$couponPK,$couponPrdFK,$couponDiscount) {
			$this->couponTable = $couponTable;
			$this->couponPK = $couponPK;
			$this->couponPrdFK = $couponPrdFK;
			$this->couponDiscount = $couponDiscount;
		}

		/**
			set if the discount is procentual or absolut
		*/
		function isProcent($isProcent = 0) {
			$this->isProcent = $isProcent;
		}

		/**
			set dates column
		*/
		function setDates($couponStartDate,$couponEndDate) {
			$this->couponStartDate = $couponStartDate;
			$this->couponEndDate = $couponEndDate;
		}
		
		/**
			set the session coupons variable
		*/
		function setSessionCoupons($sessionName) {
			if (isset($_SESSION[$sessionName])) {
				$this->sessionCoupons = $_SESSION[$sessionName];
			} else {
				$this->sessionCoupons = '';
			}
		}
		
		/**
			apply coupon discount
			@params
				$uidVal
			@return
				new price
		*/
		function applyDiscount($uidVal) {
			$newPrice = $this->oldPrice;
			if (is_array($this->sessionCoupons)) {
				$tmVc = ' in (';
				$sep = '';
				for ($vIdx = 0;$vIdx < count($this->sessionCoupons);$vIdx++) {
					$tmVc .= $sep . '\'' . $this->sessionCoupons[$vIdx] . '\'';
					if (strlen($sep) == 0) {
						$sep = ',';
					}
				}
				$tmVc .= ')';
			} else {
				$tmVc = ' = \'' . $this->sessionCoupons . '\'';
			}
			
			$sql = 	'select ' . $this->couponDiscount . ' from ' . $this->couponTable . 
							' where ' . $this->couponPrdFK . ' = ' . $uidVal . 
							' and ' . $this->couponPK . $tmVc;
			$now = date('Y-m-d');
			$sql .= ' AND \'' . $now . '\' >= ' . $this->couponStartDate;
			$sql .= ' AND \'' . $now . '\' <= ' . $this->couponEndDate;
			$rs = $this->connection->Execute($sql) or die($this->connection->ErrorMsg());
			if ($rs) {
				$minPrice = $newPrice;
				while (!$rs->EOF) {
					$tmPrice = $newPrice;
					if ($this->isProcent) {
						$tmPrice -= $tmPrice * ($rs->Fields($this->couponDiscount)/100);
					} else {
						$tmPrice -= $rs->Fields($this->couponDiscount);
					}
					if ($tmPrice < $newPrice) {
						$minPrice = $tmPrice;
					}
					$rs->MoveNext();
				}
				$newPrice = $minPrice;
			}
			
			return $newPrice;
		}
		
	}
?>
