<?php
//Predefined Discount classes
	class SpecialOffers {
		var $connection;
		var $oldPrice;
		var $uidVal;
		var $table;
		var $uniqueKeyColumn;
		var $discountColumn;
		var $startDateColumn;
		var $endDateColumn;
		
		/**
		Constructor
		*/
		function SpecialOffers() {
		}
		
		/**
			set the refference to $kartRecordset, Row index($idx) and oldPrice
			@params
				$oldPrice - old price of the column
				$uidVal - value of the Product Unique Identifier
			@return
				none
		*/
		function setDefaultInterface($oldPrice,$uidVal) {
			$this->oldPrice = $oldPrice;
			$this->uidVal = $uidVal;
		}
		
		/**
			set The Conectiion Object
			@params
				$connection - ADODB Connection reference
			@return
			none
		*/
		function setConnection(&$conn) {
			$this->connection = &$conn;
		}
		
		/**
			set the Discount Table
			@param
				$table - discount table
			@return
				none
		*/
		function setTable($table) {
			$this->table = $table;
		}
		/**
			set the Unique Key Column 
			@params
				$uniqueKeyColumn - 
			@return
				none
		*/
		function setUniqueKeyColumn($uniqueKeyColumn) {
			$this->uniqueKeyColumn = $uniqueKeyColumn;
		}


		/**
			set the discount column
			@params
				$discountColumn -
			@retuns
			none
		*/
		function setDiscountColumn($discountColumn) {
			$this->discountColumn = $discountColumn;
		}
		
		/**
			set date columns
			@params
				$startDateColumn
				$endDateColumn
			@return 
				none
		*/
		function setDatesColumns($startDateColumn,$endDateColumn) {
			$this->startDateColumn = $startDateColumn;
			$this->endDateColumn = $endDateColumn;
		}
		
		/**
		apply the user discount
			@params
				none
			@return
				 new Price
		*/
		function applyDiscount() {
			$tmSQL = 'select '.$this->discountColumn . ' from ' . $this->table . ' where ' . $this->uniqueKeyColumn . ' = ' .  $this->uidVal;
			if (isset($this->startDateColumn) && isset($this->endDateColumn)) {
				$now = date('Y-m-d');
				$tmSQL .= ' AND \'' . $now . '\' >= ' . $this->startDateColumn;
				$tmSQL .= ' AND \'' . $now . '\' <= ' . $this->endDateColumn;
			}
			$rs = $this->connection->Execute($tmSQL) or die($this->connection->ErrorMsg());
			if ($rs) {
				$discountPrice = $rs->Fields($this->discountColumn);
				if (($discountPrice != 0) && ($discountPrice < $this->oldPrice)) {
					return $discountPrice;
				}
			}
			return $this->oldPrice;
		}
		
		
		
	}
	
	?>