<?php
	//predefinet rate class
	class DestinationRate {
		var $connection;
		var $oldCost;
		var $suColumn;
		
		var $kartObject;

		var $orderZone;
		var $orderCountry;

		
		var $countryTable;
		var $countryPK;
		var $countryName;
		
		var $zoneTable;
		var $zonePK;
		var $zoneCountryFK;
		var $zoneName;
		var $zoneRate;
		
		
		//constructor
		function DestinationRate($oldCost) {
			$this->oldCost = $oldCost;
		}
		
		/**
			set the connection
		*/
		function setConnection(&$conn) {
			$this->connection = &$conn;
		}
		/**
			set the Order Table columns
		*/
		function setOrder($countryColumn,$zoneColumn) {
			$this->orderZone = $zoneColumn;
			$this->orderCountry = $countryColumn;
		}
		/**
			set Rate Table columns
		*/
		function setRate($rateTable,$ratePK,$rateRate) {
			$this->rateTable = $rateTable;
			$this->ratePK = $ratePK;
			$this->rateRate = $rateRate;
		}
		/**
			shipping unit column (from recordset)
		*/
		function setSUColumn($suColumn) {
			$this->suColumn = $suColumn;
		}
		
		/**
			set Country Table Info
		*/
		function setCountry($countryTable,$countryPK,$countryName) {
			$this->countryTable = $countryTable;
			$this->countryPK = $countryPK;
			$this->countryName = $countryName;
		}
		/**
			set Zone Table info
		*/
		function setZone($zoneTable,$zonePK,$zoneCountryFK,$zoneName,$zoneRate) {
			$this->zoneTable = $zoneTable;
			$this->zonePK = $zonePK;
			$this->zoneCountryFK = $zoneCountryFK;
			$this->zoneName = $zoneName;
			$this->zoneRate = $zoneRate;
		}
		
		/**
			set the Kart Object
		*/
		function setKartObject($kartObj) {
			$this->kartObject = $kartObj;
		}
		
		
		
		/**
			get the rate
		*/
		function getRate() {
			$rate = 0;
			$orderTable = $this->kartObject->Korders['orders']['tableName'];
			$sql = 	'select ' . $this->zoneTable . '.' . $this->zoneRate .  ' from ' . $this->zoneTable . 
							' inner join ' . $this->countryTable . 
										' ON ' . $this->countryTable . '.' . $this->countryPK . '=' . $this->zoneTable . '.' . $this->zoneCountryFK . 
							' inner join ' . $orderTable . 
										' ON ((' . $orderTable . '.' . $this->orderZone . '=' . $this->zoneTable .'.' . $this->zoneName . ') ' . 
										' AND (' . $orderTable . '.' . $this->orderCountry . '=' . $this->countryTable . '.' . $this->countryName . ')) ' . 
							' WHERE ' . $orderTable . '.' . $this->kartObject->Korders['orders']['pk'] . ' = \'' . $this->kartObject->getOrderID() . '\'';
			$rs = $this->connection->Execute($sql) or die($this->connection->ErrorMsg());
			if ($rs) {
				$rate = $rs->Fields($this->zoneRate);
			}
			return $this->oldCost + $rate * $this->kartObject->Fields($this->suColumn);
		}
	}
?>