<?php 
	//predefined rate class
	class ZoneTax {
		var $connection;
		var $oldCost;
		var $kartObject;

		var $orderZone;
		var $orderCountry;

		var $countryTable;
		var $countryPK;
		var $countryName;
		
		var $zoneTable;
		var $zonePK;
		var $zoneCountryFK;
		var $zoneTaxFK;
		var $zoneName;

		var $productTable;
		var $productPK;
		var $productCategFK;
		
		var $taxTable;
		var $taxZoneFK;
		var $taxCategFK;
		var $taxAmount;
		

		//constructor
		function ZoneTax($oldCost) {
			$this->oldCost = $oldCost;
		}
		
		/**
			set the connection
		*/
		function setConnection(&$conn) {
			$this->connection = &$conn;
		}
		
		
		/**
			set the Kart Object
		*/
		function setKartObject($kartObj) {
			$this->kartObject = $kartObj;
			$this->orderZone = $this->kartObject->Korders['orders']['state'];//$zoneColumn;
			$this->orderCountry = $this->kartObject->Korders['orders']['country'];//$countryColumn;
		}

		/**
			set Country Table Info
		*/
		function setCountry($countryTable,$countryPK,$countryName) {
			$this->countryTable = $countryTable;
			$this->countryPK = $countryPK;
			$this->countryName = $countryName;
		}
		/**
			set Zone Table info
		*/
		function setZone($zoneTable,$zonePK,$zoneCountryFK,$zoneTaxFK,$zoneName) {
			$this->zoneTable = $zoneTable;
			$this->zonePK = $zonePK;
			$this->zoneCountryFK = $zoneCountryFK;
			$this->zoneTaxFK = $zoneTaxFK;
			$this->zoneName = $zoneName;
		}
		
		/***
			set Product Table Info
		*/
		function setProductTable($productTable,$productPK,$productCategFK) {
			$this->productTable = $productTable;
			$this->productPK = $productPK;
			$this->productCategFK = $productCategFK;
		}
		/**
			set Tax Table Info
		*/
		function setTaxTable($taxTable,$taxZoneFK,$taxCategFK,$taxAmount) {
			$this->taxTable = $taxTable;
			$this->taxZoneFK = $taxZoneFK;
			$this->taxCategFK = $taxCategFK;
			$this->taxAmount = $taxAmount;
		}
		
		/**
			apply the taxes
		*/
		function getTax($index) {
			$amount = 0;
			$orderTable = $this->kartObject->Korders['orders']['tableName'];
			$productPK = $this->kartObject->fields[$index][$this->kartObject->unique];
			$sql = 	'select ' . $this->taxTable . '.' . $this->taxAmount . 
							' from ' . $this->taxTable . 
							' inner join ' . $this->zoneTable . 
										' ON ' . $this->zoneTable . '.' . $this->zoneTaxFK . ' = ' . $this->taxTable . '.' . $this->taxZoneFK . 
							' inner join ' . $this->countryTable . 
										' ON ' . $this->countryTable . '.' . $this->countryPK . '=' . $this->zoneTable . '.' . $this->zoneCountryFK . 
							' inner join ' . $orderTable . 
										' ON ((' . $orderTable . '.' . $this->orderZone . '=' . $this->zoneTable . '.' . $this->zoneName . ') ' . 
										' AND (' . $orderTable . '.' . $this->orderCountry . '=' . $this->countryTable . '.' . $this->countryName . ')) ' . 
							' inner join ' . $this->productTable . 
										' ON ' . $this->productTable . '.' . $this->productCategFK . '=' . $this->taxTable . '.' . $this->taxCategFK .
							' WHERE ' . $orderTable . '.' . $this->kartObject->Korders['orders']['pk'] . ' = \'' . $this->kartObject->getOrderID() . '\' ' .
									' AND ' . $this->productTable . '.' . $this->productPK . '=' . $productPK;
			
			$rs = $this->connection->Execute($sql) or die($this->connection->ErrorMsg());
			if ($rs) {
				$amount = $rs->Fields($this->taxAmount);
			}
			
			return $this->oldCost + $amount/100 * $this->kartObject->getSubTotal($index);
		
		}
	}

?>
