<?php
	require_once("kartProps.inc.php");

	function pgpmail($mailto, $emailsubject, $body, $emailfrom, $recipient, $pgppath, $GNUPGHOME) {
		global $kartProps;
		//Tell gnupg where the key ring is. Home dir of user web server is running as.
		putenv("GNUPGHOME=$GNUPGHOME");
		$home_dir = $kartProps['payment']['properties']['HOMEDIR'];
		$user_env = $kartProps['payment']['properties']['USERNAME']; 

		//create a unique file name
		$infile = tempnam("", "PGP.asc");
		$outfile = $infile.".asc";

		//write form variables to email
		$fp = fopen($infile, "w");
		fwrite($fp, $body);
		fclose($fp);

		//set up the gnupg command. Note: Remember to put E-mail address on the gpg keyring.
		$command = "HOME=$home_dir USER=$user_env $pgppath -a --always-trust --recipient \"$recipient\" --encrypt -o $outfile $infile 2>&1";

		//execute the gnupg command
		ob_start();
		$resultTxt = system($command, $result);
		$errTxt = ob_get_contents();
		ob_clean();
		$resultTxt = nl2br($errTxt) . "$resultTxt";

		//delete the unencrypted temp file
		unlink($infile);

		if ($result==0) {
			$fp = fopen($outfile, "r");
			
			if(!$fp||filesize ($outfile)==0) {
				$result = -1;
			} else {
				//read the encrypted file
				$contents = fread ($fp, filesize ($outfile));
				//delete the encrypted file
				unlink($outfile);


				//send the email
				$ret = mail ($mailto, $emailsubject, $contents, $emailfrom);
				if ($ret) {
					return true;
				} else {
					return "Error sending mail. mail() call problem!";
				}
			 } 
		}

		if($result!=0) {
				 return "Error sending mail: <br>$resultTxt.";
		}
	}

	if (isset($_POST['ccno']) && $_POST['ccno'] != '') {
		$emailto      = $kartProps['payment']['properties']['emailto'];
		$recipient    = $kartProps['payment']['properties']['recipient'];
		$emailsubject = $kartProps['payment']['properties']['emailsubject'];
		$emailfrom    = "From: " . $kartProps['payment']['properties']['emailfrom'];
		$pgppath      = $kartProps['payment']['properties']['pgppath'];
		$GNUPGHOME    = $kartProps['payment']['properties']['GNUPGHOME'];

		$content = "Payment Details:\r\n\r\n";
		while (list($key, $value) = each($_POST)) {
			$content .= str_pad($key, 16) . " = $value\r\n";
		}

		$response = pgpmail($emailto, $emailsubject, $content, $emailfrom, $recipient, $pgppath, $GNUPGHOME);
		if ($response === true) {
			$response_code = 'success';
			$response_reason_text = 'Mail sent!';
		} else {
			$response_code = 'Failed';
			$response_reason_text = $response;
		}
	}
?>
<html>
<head>
</head>
<body>
<?php
	if (isset($response_code)) {
		$amount = $_POST['amount'];
?>
<form name="form2" method="post" action="<?php echo $_POST['returnUrl']; ?>">
<input name="response_code" type="hidden" id="response_code" value="<?php echo $response_code; ?>">
<input name="response_reason_text" type="hidden" id="response_reason_text" value="<?php echo htmlspecialchars($response_reason_text); ?>">
<input name="myParam" type="hidden" id="myParam" value="<?php echo $_POST['myParam']; ?>">
<input name="amount" type="hidden" id="amount" value="<?php echo $_POST['amount']; ?>">
<input name="currency_code" type="hidden" id="currency_code" value="<?php echo $_POST['currency_code']; ?>">
<input type="submit" name="Submit2" value="Please Wait ...">
</form>
<script>
	document.forms[0].submit();
</script>
<?php	
		die();
	}
?>
<form name="form1" method="post" action="">
Please enter your credit card details. Your request will be processed by us as soon as possible.
<hr>
Pay <?php echo $_POST['amount']; ?> <?php echo $_POST['currency_code']; ?>
<hr>
<?php
	if (isset($_POST['ccno'])) {
?>
<font color="red">
Unable to process payment!<br>
Please re-enter the Credit Card Number and expiration date.<br>
<?php echo @$response_code; ?>
</font>
<?php
	}
?>
<table border="0">
  <tr>
    <td align="right">Card Holder:</td>
    <td><?php echo $_POST['first_name']; ?>
<?php echo $_POST['last_name']; ?> </td>
  </tr>
  <tr>
    <td align="right">Credit Card No:</td>
    <td><input name="ccno" type="text" id="ccno" maxlength="255"></td>
  </tr>
  <tr>
    <td align="right">Expiration Date:</td>
		<td>
      <select name="expmo" id="expmo">
        <option value="01">01</option>
        <option value="02">02</option>
        <option value="03">03</option>
        <option value="04">04</option>
        <option value="05">05</option>
        <option value="06">06</option>
        <option value="07">07</option>
        <option value="08">08</option>
        <option value="09">09</option>
        <option value="10">10</option>
        <option value="11">11</option>
        <option value="12">12</option>
      </select>
			<select name="expy" id="expy">
      <option value="04">04</option>
      <option value="05">05</option>
      <option value="06">06</option>
      <option value="07">07</option>
      <option value="08">08</option>
      <option value="09">09</option>
      <option value="10">10</option>
    </select>
</td>
  </tr>
  <tr>
    <td align="right">Country:</td>
    <td><?php echo $_POST['country']; ?></td>
  </tr>
  <tr>
    <td align="right">State / Province / Region:</td>
    <td><?php echo $_POST['state']; ?></td>
  </tr>
  <tr>
    <td align="right">City:</td>
    <td><?php echo $_POST['city']; ?></td>
  </tr>
  <tr>
    <td align="right">Address:</td>
    <td><?php echo $_POST['address']; ?></td>
  </tr>
  <tr>
    <td align="right">Zip:</td>
    <td><?php echo $_POST['zip']; ?></td>
  </tr>
  <tr>
    <td align="right">Phone:</td>
    <td><?php echo $_POST['phone']; ?></td>
  </tr>
  <tr>
    <td align="right">E-mail:</td>
    <td><?php echo $_POST['email']; ?></td>
  </tr>
  <tr>
    <td align="right">&nbsp;</td>
    <td><input type="submit" name="Submit" value="Make Payment"></td>
  </tr>
</table>
<p>
  <input name="currency_code" type="hidden" id="currency_code" value="<?php echo $_POST['currency_code']; ?>">
  <input name="amount" type="hidden" id="amount" value="<?php echo $_POST['amount']; ?>">
  <input name="first_name" type="hidden" id="currency_code3" value="<?php echo $_POST['first_name']; ?>">
  <input name="last_name" type="hidden" id="first_name" value="<?php echo $_POST['last_name']; ?>">
  <input name="address" type="hidden" id="last_name" value="<?php echo $_POST['address']; ?>">
  <input name="city" type="hidden" id="city" value="<?php echo $_POST['city']; ?>">
  <input name="state" type="hidden" id="state" value="<?php echo $_POST['state']; ?>">
  <input name="zip" type="hidden" id="city3" value="<?php echo $_POST['zip']; ?>">
  <input name="country" type="hidden" id="city22" value="<?php echo $_POST['country']; ?>">
  <input name="phone" type="hidden" id="city5" value="<?php echo $_POST['phone']; ?>">
  <input name="email" type="hidden" id="phone" value="<?php echo $_POST['email']; ?>">
  <input name="myParam" type="hidden" id="email" value="<?php echo $_POST['myParam']; ?>">
  <input name="returnUrl" type="hidden" id="returnUrl" value="<?php echo $_POST['returnUrl']; ?>">
</p>
</form>
</body>
</html>
